' Rdparser.bas  
' Copyright:(c) sarbayo, 2012 

' special credits to: Jack Crenshaw's:
'   "How to Build a Compiler" 

' This is an: LALR-RD Parser (Look-Ahead, Left-to-Right, Recursive-Descent)
' Based on: Rdparser.c, in Bxbasic 

'  DUMP 210
  
' ----- function prototypes ----- 
'------ rdparser.c ------
    DECLARE SUB main()
    DECLARE SUB Expression()
    DECLARE SUB Term()
    DECLARE SUB Factor()
    DECLARE SUB Match()
    DECLARE SUB GetChar()
    DECLARE SUB GetNum()
    DECLARE SUB IsAddop(a$)
    DECLARE SUB IsMultop(a$)
    DECLARE SUB IsWhite(a$)
    DECLARE SUB SkipWhite()
    DECLARE SUB asc2dbl()
    DECLARE SUB mathfunctn()
    DECLARE SUB abort(a,b)
    DECLARE SUB IsAlpha(a$)
    DECLARE SUB IsDigit(a$)


'--------------------- SYSTEM VARIABLES ---------------------
    DIM pstring$(1)
    DIM tholder$ = ""
    DIM xstring$ = ""
    DIM epos = 1, len = 0
    DIM dreturn# = 0, ireturn = 0

' ----- begin program ------------- 
    CLS
    CALL main()
    Print
'    
TheEnd:
'    Pause
    END
'===========================================================

SUB main()
    DIM value# = 0
    DIM ii = 0
    DIM instring$ = ""
'
    Print
    Print  "LALR Parser"
    Print
    Print "Enter Expression: Example: 1+2*3*4*10/5"
    Locate 4,18
    INPUT instring$
'
    IF instring$ = "" THEN
        GOTO DoneMain             ' abort
    ENDIF
'
    len = LEN(instring$)
    ii = len + 1
    REDIM pstring$(ii)
'
    FOR ii = 1 TO len
        pstring$(ii) = MID$(instring$, ii, 1)
    NEXT ii
    pstring$(ii) = CHR$(0)
'
    CALL Expression()        ' --- call math parser --- 
    value# = dreturn#
    Print " ", "result ="; value#
'
DoneMain:
'
ENDSUB
'--------- end main ---------


SUB Expression()        ' Parse and Translate an Expression 
    DIM ch$ = ""
    DIM pi = 0, isaddop = 0, ich = 0
    DIM eValue# = 0
                              Print "SUB Expression()"
    pi = epos
    ch$ = pstring$(pi)
                              Print "Exp::pi="; pi; " ch$="; ch$
    CALL IsAddop(ch$)
    isaddop = ireturn

    IF isaddop = 1 THEN
        eValue# = 0
    ELSE
        CALL Term()
        eValue# = dreturn#
        pi = epos
        ch$ = pstring$(pi)
    ENDIF
                              pi = epos
                              Print "Exp::value="; eValue#; "pi="; pi; " ch$="; ch$
    CALL IsAddop(ch$)
    isaddop = ireturn
                              Print "Exp::isaddop="; isaddop
    WHILE isaddop = 1 
        ich = ASC(ch$)
                              Print "Exp::isaddop="; isaddop; " ich="; ich
        SWITCH ich
            CASE 43
                              pi = epos
                              Print "Exp::value="; eValue#; "pi="; pi
                CALL Match()
                CALL Term()
                eValue# = eValue# + dreturn#
                              pi = epos
                              Print "Exp::value="; eValue#; "pi="; pi
            CASE 45
                CALL Match()
                CALL Term()
                eValue# = eValue# - dreturn#
        ENDSWITCH
        pi = epos
        ch$ = pstring$(pi)
        CALL IsAddop(ch$)
        isaddop = ireturn
    WEND

    dreturn# = eValue#
ENDSUB
'---------- end Expression ----------


SUB Term()                  ' Parse and Translate a Math Term 
    DIM ch$ = ""
    DIM pi = 0
    DIM tValue# = 0
    DIM ismultop = 0, ich = 0
                              Print "SUB Term()"
    CALL Factor()
    tValue# = dreturn#
                               pi = epos
                               Print "Term::value="; tValue#; "pi="; pi
    pi = epos
    ch$ = pstring$(pi)

    CALL IsMultop(ch$)
    ismultop = ireturn
    
    WHILE ismultop = 1
        ich = ASC(ch$)

        SWITCH ich
            CASE 42
                CALL Match()
                CALL Factor()
                tValue# = tValue# * dreturn#
            CASE 47
                CALL Match()
                CALL Factor()
                tValue# = tValue# / dreturn#
            CASE 94
                CALL Match()
                CALL Factor()
                tValue# = tValue# ^ dreturn#
            CASE 37
                CALL Match()
                CALL Factor()
                ireturn = INT(dreturn#)
                tValue# = INT(tValue#)
                tValue# = tValue# % ireturn
        ENDSWITCH
        pi = epos
        ch$ = pstring$(pi)
        CALL IsMultop(ch$)
        ismultop = ireturn
    WEND
                               Print "Term::value="; tValue#; "pi="; pi
    dreturn# = tValue#
ENDSUB
'---------- end Term ----------


SUB Factor()                   ' Parse and Translate a Math Factor 
    DIM ch$ = ""
    DIM pi = 0, isalpha = 0
    DIM fvalue# = 0
                               Print "SUB Factor()"
    pi = epos
    ch$ = pstring$(pi)
                               Print "Fact::pi="; pi; " ch$="; ch$
    IF ch$ = "(" THEN
        CALL Match()
                               pi = epos
                               ch$ = pstring$(pi)
                               Print "Fact::pi="; pi; " ch$="; ch$
        CALL Expression()
                               pi = epos
                               ch$ = pstring$(pi)
                               Print "<<Fact::pi="; pi; " ch$="; ch$
        fvalue# = dreturn#
        CALL Match()
                               pi = epos
                               ch$ = pstring$(pi)
                               Print "<<<Fact::pi="; pi; " ch$="; ch$
    ELSE
        CALL GetNum()
        fvalue# = dreturn#
    ENDIF
                               pi = epos
                               Print "Fact::value="; fvalue#; "pi="; pi
    dreturn# = fvalue#
ENDSUB
'---------- end Factor ----------



'====================== rdp utility routines ======================

SUB Match()             ' Match a specific input character 
    DIM ch$ = ""
    DIM sstring$ = ""
    DIM pi = 0, abcode = 12, ln = 1
                               Print "SUB Match()"
    pi = epos
    ch$ = pstring$(pi)

    IF pi < len THEN
        CALL GetChar()
        CALL SkipWhite()
    ENDIF

ENDSUB
'---------- end Match ----------


SUB GetChar()
                               Print "SUB GetChar()"
    epos = epos + 1
                               Print "GetChar::epos="; epos
ENDSUB
'---------- end GetChar ----------


SUB IsWhite(ch$)
    DIM test = 0
    DIM tab$ = ""
                               Print "SUB IsWhite(ch$)"
    tab$ = CHR$(9)

    IF ch$ = " " OR ch$ = tab$
        test = -1
    ENDIF
                               Print "IsWhite::test="; test
    ireturn = test
ENDSUB
'---------- end IsWhite ----------


SUB SkipWhite()        ' Skip Over Leading White Space 
    DIM ch$ = ""
    DIM pi = 0, iswhite = 0
                               Print "SUB SkipWhite()"
    pi = epos
    ch$ = pstring$(pi)

    CALL IsWhite(ch$)
    iswhite = ireturn

    WHILE iswhite <> 0
        CALL GetChar()
        pi = epos
        ch$ = pstring$(pi)
        CALL IsWhite(ch$)
        iswhite = ireturn
    WEND
                               pi = epos
                               ch$ = pstring$(pi)
                               Print "SkipWhite::pi="; pi; " ch$="; ch$
ENDSUB
'---------- end SkipWhite ----------


SUB GetNum()        ' Get a Number 
    DIM ch$ = ""
    DIM pi = 0, isdigit = 0
    DIM abcode = 12, ln = 1
    DIM gvalue# = 0
                               Print "SUB GetNum()"
    pi = epos
    ch$ = pstring$(pi)

    CALL IsDigit(ch$)
    isdigit = ireturn

    IF isdigit = 0 THEN
        tholder$ =  "Numeric Value"
        CALL abort(abcode, ln)
    ENDIF

    CALL asc2dbl()
    gvalue# = dreturn#
                               Print "GetNum::value#="; gvalue#
    pi = epos
    ch$ = pstring$(pi)
                               Print "GetNum::pi="; pi; " ch$="; ch$
    CALL IsDigit(ch$)
    isdigit = ireturn

    IF isdigit = 1 THEN
        While isdigit = 1
            pi = pi + 1
            ch$ = pstring$(pi)
            CALL IsDigit(ch$)
            isdigit = ireturn
        WEND
        epos = pi
    ENDIF

    CALL SkipWhite()

    dreturn# = gvalue#
ENDSUB
'---------- end GetNum ----------


SUB IsAddop(ch$)             ' Recognize an Addop 
    DIM rval = 0, result = 0
                               Print "SUB IsAddop(ch$)"
    IF ch$ = "+" OR ch$ = "-" THEN
        rval = 1
    ENDIF
                               Print "IsAddop="; rval
    ireturn = rval
ENDSUB
'---------- end IsAddop ----------


SUB IsMultop(ch$)            ' Recognize an Multop 
    DIM rval = 0, result = 0
                               Print "SUB IsMultop(ch$)"
     IF ch$ = "*" OR ch$ = "^" OR ch$ = "%" OR ch$ = "/" THEN
        rval = 1
    ENDIF
                               Print "IsMultop="; rval
    ireturn = rval
ENDSUB
'---------- end IsMultop ----------


SUB asc2dbl()
    DIM ch$ = "", cvalue$ = ""
    DIM pi = 0, isdigit = 0
    DIM fvalue# = 0
                               Print "SUB asc2dbl()"
    pi = epos
    ch$ = pstring$(pi)

    CALL IsDigit(ch$)
    isdigit = ireturn

    While isdigit = 1
        cvalue$ = cvalue$ + ch$
        pi = pi + 1
        ch$ = pstring$(pi)
        CALL IsDigit(ch$)
        isdigit = ireturn
    WEND

    fvalue# = VAL(cvalue$)                 ' convert ascii to float 
    epos = pi

    dreturn# = fvalue#
ENDSUB
'------- end asc2dbl ---------


SUB IsDigit(ch$)
    DIM test = 0, val = 0
                               Print "SUB IsDigit(ch$)"
    val = ASC(ch$)

    IF val >= 48 AND val <= 57 OR ch$ = "." THEN
        test = 1
    ENDIF
                               Print "IsDigit="; test
    ireturn = test
ENDSUB
'---------- end IsDigit ----------


SUB abort(code, linendx)
    DIM instring$ = ""
    DIM ii = 0

    FOR ii = 1 TO len
        instring$ = instring$ + pstring$(ii)
    NEXT ii

    BEEP

    Switch code
        Case 12
            Print
            Print "Expected "; tholder$; " ";
            Print ": in line: "; (linendx + 1)
            Print instring$
            Print "code("; code; ")"
        DEFAULT
            Print "Program aborted, undefined error."
    ENDSWITCH

    END
ENDSUB
'----------end abort -----------


SUB IsAlpha(ch$)
    DIM test = 0, val = 0
                               Print "SUB IsAlpha(ch$)"
    val = ASC(ch$)

    IF val >= 65 AND val <= 90 OR val >= 97 AND val <= 122 THEN
        test = 1
    ENDIF

    ireturn = test
ENDSUB
'----------end IsAlpha -----------







